(* file: rational.ml
   author: Bob Muller

   CS1103 Computer Science I Honors

   Lecture Notes/Code for Week 14

   Topic:

   Using OCaml's module system to make new types.  We use an example of rational
   numbers.  This file contains a module structure implementing the signature
   specified in the accompanying rational.mli file.

 *)
type t = {numerator : int; denominator : int}

let rec gcd m n =
  match n = 0 with
  | true  -> m
  | false -> gcd n (m mod n)

let make m n =
  let gcd = gcd m n
  in
  {numerator = m / gcd; denominator = n / gcd}

let toString {numerator; denominator} =
  (string_of_int numerator) ^ "/" ^ (string_of_int denominator)
                                      
let add r1 r2 = 0
let compare r1 r2 = 0
